package envoy.server.processors;

import java.io.IOException;

import envoy.event.GroupCreationEvent;
import envoy.server.data.PersistenceManager;
import envoy.server.net.ObjectWriteProxy;

/**
 * Project: <strong>envoy-server-standalone</strong><br>
 * File: <strong>GroupCreationProcessor.java</strong><br>
 * Created: <strong>26.03.2020</strong><br>
 * 
 * @author Maximilian K&auml;fer
 * @since Envoy Server Standalone v0.1-beta
 */
public class GroupCreationProcessor implements ObjectProcessor<GroupCreationEvent> {

	private final PersistenceManager	persistenceManager	= PersistenceManager.getInstance();

	@Override
	public void process(GroupCreationEvent input, long socketID, ObjectWriteProxy writeProxy) throws IOException {
		envoy.server.data.Group group = new envoy.server.data.Group();
		group.setName(input.get());
		// TODO adjust event, so it sends a members list as well, which can be initially
		// set here
		persistenceManager.addContact(group);
		writeProxy.write(socketID, group); // TODO Prepare the client to receive the group object after sending the
											// groupCreationEvent to the server.
	}

	@Override
	public Class<GroupCreationEvent> getInputClass() { return GroupCreationEvent.class; }
}
